/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.2c Standard
Automatic Program Generator
 Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : GSM ALARM
Version : 0.99
Date    : 22.12.2005
Author  : black_kite@bk.ru                       
Company :                                 
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 7,372800 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <stdlib.h>
//
#define in1 PINC.0
#define in2 PINC.1
#define in3 PINC.2
#define in4 PINC.3
#define in5 PINC.4
#define in6 PINC.5
#define powsens PINB.1
#define key PIND.5
//
#define out1 PORTD.6
#define out2 PORTD.7
#define out3 PORTB.0
#define out4 PORTB.4
#define zub  PORTD.2
#define zubdr DDRD.2
#define bat  PORTD.3
#define batdr DDRD.3
#define sled PORTD.4
#define iled PORTB.3

// 1 Wire Bus functions
#asm
   .equ __w1_port=0x18 ;PORTB
   .equ __w1_bit=2
#endasm
#include <1wire.h>

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 64
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
}

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;
}
#pragma used-
#endif

// USART Transmitter buffer
#define TX_BUFFER_SIZE 64
char tx_buffer[TX_BUFFER_SIZE];

#if TX_BUFFER_SIZE<256
unsigned char tx_wr_index,tx_rd_index,tx_counter;
#else
unsigned int tx_wr_index,tx_rd_index,tx_counter;
#endif

// USART Transmitter interrupt service routine
interrupt [USART_TXC] void usart_tx_isr(void)
{
if (tx_counter)
   {
   --tx_counter;
   UDR=tx_buffer[tx_rd_index];
   if (++tx_rd_index == TX_BUFFER_SIZE) tx_rd_index=0;
   };
}

#ifndef _DEBUG_TERMINAL_IO_
// Write a character to the USART Transmitter buffer
#define _ALTERNATE_PUTCHAR_
#pragma used+
void putchar(char c)
{
while (tx_counter == TX_BUFFER_SIZE);
#asm("cli")
if (tx_counter || ((UCSRA & DATA_REGISTER_EMPTY)==0))
   {
   tx_buffer[tx_wr_index]=c;
   if (++tx_wr_index == TX_BUFFER_SIZE) tx_wr_index=0;
   ++tx_counter;
   }
else
   UDR=c;
#asm("sei")
}
#pragma used-
#endif

// Standard Input/Output functions
#include <stdio.h>

unsigned int Tdelay[12];//   10 
unsigned int pcount[12];//   10 
unsigned char istatus[12];//  
			  //0- ()
			  //1-  
			  //2- 
			  //(   )
unsigned int sec;// 0.1
unsigned char sledpw;//pwm  
unsigned char iledpw;//pwm   
unsigned char pwcnt;// pwm'
unsigned char iphone;//   .
unsigned char icall;//1-     
unsigned char batcount;//   
unsigned char ipwcnt=0;//    
//   sms
#define SMS_BUFFER_SIZE 64
unsigned char sms_buffer[SMS_BUFFER_SIZE];

unsigned char sms_wr_index,sms_rd_index,sms_counter;
unsigned char sms_proc=0;
void PutSMS(unsigned char smsn)
{
 sms_buffer[sms_wr_index]=smsn;
 if (++sms_wr_index == SMS_BUFFER_SIZE) sms_wr_index=0;
 if (++sms_counter == SMS_BUFFER_SIZE) sms_counter=0;
}

unsigned char GetSMS(void)
{
char smsn;
smsn=sms_buffer[sms_rd_index];
if (++sms_rd_index == SMS_BUFFER_SIZE) sms_rd_index=0;
if (sms_counter)sms_counter--;
return smsn;
}

// Timer 1 overflow interrupt service routine
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
char i;
// Reinitialize Timer 1 value
TCNT1H=0xFD;
TCNT1L=0x30;
// Place your code here
if(sec)sec--;
for(i=0;i<12;i++)if(Tdelay[i])Tdelay[i]--;
if((pwcnt++)>9){pwcnt=0;iphone=(iphone+1)&3;if(sms_proc)sms_proc--;}
sled=(sledpw>pwcnt);
iled=(iledpw>pwcnt);
if(ipwcnt){iled=1;ipwcnt--;}
batcount++;
if(batcount<25){batdr=1;zubdr=1;bat=1;zub=0;}else{batdr=0;zubdr=0;bat=0;zub=0;}
}

// Declare your global variables here

void init_prog(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=Out Func3=Out Func2=In Func1=In Func0=Out 
// State7=T State6=T State5=T State4=0 State3=0 State2=T State1=T State0=0 
PORTB=0x00;
DDRB=0x19;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=Out Func6=Out Func5=In Func4=Out Func3=Out Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=T State4=0 State3=0 State2=0 State1=T State0=T 
PORTD=0x00;
DDRD=0xDC;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,200 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x05;
TCNT1H=0xFD;
TCNT1L=0x30;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x04;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 19200
UCSRA=0x00;
UCSRB=0xD8;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x17;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
ACSR=0x80;
SFIOR=0x00;

// 1 Wire Bus initialization
w1_init();

// Global enable interrupts
#asm("sei");
sms_wr_index=0;
sms_rd_index=0;
sms_counter=0;
}           


#include <delay.h>
// 
eeprom char cdata[16*20];//   20  -
eeprom char ibase[8*24];//  iButton
char idata[9];// 
char powstate;//     
void InitDev(void)// 
{
unsigned int i;
for(i=0;i<12;i++)
 {
 pcount[i]=i*16;
 Tdelay[i]=0;
 istatus[i]=0;
 }
}

//  
char cmp8byte(char * fd,eeprom char * rd)
{
if (rd[0]!=fd[0])return 0;
if (rd[1]!=fd[1])return 0;
if (rd[2]!=fd[2])return 0;
if (rd[3]!=fd[3])return 0;
if (rd[4]!=fd[4])return 0;
if (rd[5]!=fd[5])return 0;
if (rd[6]!=fd[6])return 0;
if (rd[7]!=fd[7])return 0;
return 1;
}

char SearchKey()
{
unsigned char i;
for(i=0;i<24;i++)
if(cmp8byte(idata,&ibase[i*8]))return 1;
return 0;
}

void ProgKey(void)
{
unsigned char i,iptr;
iptr=0;
iledpw=1;
sledpw=1;
for(i=0;i<8*24;i++)ibase[i]=0xAA;// 
sec=200;
while((sec!=0)&&(iptr<24))
 {
       	if(w1_init())
      	{
      	for (i=0;i<8;i++)idata[i]=0;
        w1_search(0xf0,idata);
        if((w1_dow_crc8(idata,8)==0)&&(SearchKey()==0)&&(idata[0]!=0))
        	 {
                 for (i=0;i<8;i++)ibase[iptr*8+i]=idata[i];
                 iptr++;
        	 sledpw=10;
        	 iledpw=10;
        	 delay_ms(1000);
        	 sledpw=1;
        	 iledpw=1;
        	 sec=200;
        	 }
        }
 }
 iledpw=0;
 sledpw=1;
}

 
void OutOn(char num)
{
   switch (num) {
        case 1:out1=1;break;
        case 2:out2=1;break;
        case 3:out3=1;break;
        case 4:out4=1;break;
        default:break;
    		 }
}

void OutOff(char num)
{
   switch (num) {
        case 0:out1=0;
               out2=0;
               out3=0;
               out4=0;break;
        case 1:out1=0;break;
        case 2:out2=0;break;
        case 3:out3=0;break;
        case 4:out4=0;break;
        default:break;
                 }
}

unsigned int GetDigit(eeprom char * digstr)
{
char i=0;
char str[]="0123";
while ((digstr[i]>='0')&&(digstr[i]<='9')&&(i<3))
	{
	str[i]=digstr[i];
	i++;
	}
str[i]=0;
return atoi(str);
}

void SendCR(void)
{
putchar(13); 
putchar(10);
}

void InitPhone(void)
{
printf("ATZ");
SendCR();
delay_ms(200); 
printf("ATE0");
SendCR();
delay_ms(200); 
printf("AT+CPBS=SM"); 
SendCR();
delay_ms(200);
if(rx_counter)while(rx_counter)getchar();
}

void Read2Flash(void)
{
unsigned char i,a;
unsigned int x,n,cptr;           
char str[]="123";
sledpw=8;
InitPhone();
if(rx_counter)while(rx_counter)getchar();
for(n=0;n<20*16;n++)cdata[n]=0;// eeprom 
for(n=0;n<17;n++)
{
printf("AT+CPBR=");
ltoa(n+1,str);
i=0;             
while(str[i])putchar(str[i++]);
SendCR();
delay_ms(500);
i=0;x=0;
if(rx_counter)
while(rx_counter)
  {
  a=getchar();
  if((i==3)&&(a!='"')&&(x<16)){cptr=x+n*16;cdata[cptr]=a;x++;}
  if(a=='"')i++;
  }
}
printf("AT+CPBR=10");//    10 
SendCR();
delay_ms(500);
i=0;x=0;
if(rx_counter)
while(rx_counter)
  {
  a=getchar();
  if((i==1)&&(a!='"')&&(x<16)){cptr=x+17*16;cdata[cptr]=a;x++;}
  if(a=='"')i++;
  }
printf("AT+CPBR=11");//    11 
SendCR();
delay_ms(500);
i=0;x=0;
if(rx_counter)
while(rx_counter)
  {
  a=getchar();
  if((i==1)&&(a!='"')&&(x<16)){cptr=x+18*16;cdata[cptr]=a;x++;}
  if(a=='"')i++;
  }
printf("AT+CPBR=12");//    12 
SendCR();
delay_ms(500);
i=0;x=0;
if(rx_counter)
while(rx_counter)
  {
  a=getchar();
  if((i==1)&&(a!='"')&&(x<16)){cptr=x+19*16;cdata[cptr]=a;x++;}
  if(a=='"')i++;
  }
sledpw=0;
  for(cptr=0;cptr<20*16;cptr++){sled=(cdata[cptr]>0);delay_ms(16);}
sledpw=1;
}

void SendSMS(unsigned char smsn) // sms  
{
char str[]="123";
int i=0;
printf("AT+CMSS=");
ltoa(smsn,str);
while(str[i])putchar(str[i++]);
SendCR();
}

void DeactiveDevice(unsigned char n)//   
				    //n=0    - 
{
unsigned char i;
if(n<7)
{
if(n)
 {
  n--;
  if((cdata[n*16]=='-')||(cdata[n*16]=='+'))
  {
   Tdelay[n]=0;
   istatus[n]=2;
   pcount[n]=n*16;
  }
 }
 else
 for(i=0;i<6;i++)
 {
 switch (cdata[i*16])
  {
        case '+':
        case '-':
        Tdelay[i]=0;
        istatus[i]=2;
        pcount[i]=i*16;
        break;
        
        default:
        break;
  }
 }
}
}

void ActiveDevice(unsigned char n)//   
				  //n=0    - 
{
unsigned char i;
if(n<7)
{
if(n)
 {
  n--;
  Tdelay[n]=0;
  istatus[n]=0;
  pcount[n]=n*16;
 }
 else
 for(i=0;i<6;i++)
 {
 switch (cdata[i*16])
  {
        case '+':
        case '-':
        Tdelay[i]=0;
        istatus[i]=0;
        pcount[i]=i*16;
        break;
        
        default:
        break;
  }
 }
}
}

void CommandInterpretator(char curprog)
{
int adr;
adr=pcount[curprog];
   switch (cdata[adr]) 
   {
//sms
        case 's':
        case 'S':
        PutSMS(GetDigit(&cdata[adr+1]));
        break;
//delay  
        case 'd':
        case 'D':
        Tdelay[curprog]=10*GetDigit(&cdata[adr+1]);
        break;
//delay  
        case 'm':
        case 'M':
        Tdelay[curprog]=600*GetDigit(&cdata[adr+1]);
        break;
//on
        case 'c':
        case 'C':
        OutOn(GetDigit(&cdata[adr+1]));
        break;
//off
        case 'r':
        case 'R':
        OutOff(GetDigit(&cdata[adr+1]));
        break;
//branch
        case 'n':
        case 'N':
        pcount[curprog]=16*(GetDigit(&cdata[adr+1])-1)-1;
        break;
//passive
        case 'p':
        case 'P':
        DeactiveDevice(GetDigit(&cdata[adr+1]));
        break;
//active
        case 'a':
        case 'A':
        ActiveDevice(GetDigit(&cdata[adr+1]));
        break;
//zvonok
        case 'z':
        case 'Z':
        if(icall==0)
        {
        printf("ATH");
        SendCR();
        icall=1;
        Tdelay[curprog]=8;
        pcount[curprog]--;
        }
        else
        {              
        printf("ATD>");
        putchar(cdata[adr+1]);
        if((cdata[adr+2]>='0')&&(cdata[adr+2]<='9'))putchar(cdata[adr+2]);
        putchar(';');
        SendCR();
        }
        break;
//otboy
        case 'x':
        case 'X':
        printf("ATH");
        SendCR();
        icall=0;
        break;
                
        default:
        break;
   }
}

void ScanIN1(void)
{
unsigned int n=0;
if((cdata[n*16]=='*')&&(!in1)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='-')&&(!in1)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='+')&&(in1)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((istatus[n]==1)&&(Tdelay[n]==0))
 {
 pcount[n]++;
 if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
  switch (cdata[n*16])
  {
        case '+':
        case '-':
        Tdelay[n]=0;
        istatus[n]=2;
        pcount[n]=n*16;
        break;
        case '*':
        Tdelay[n]=0;
        istatus[n]=0;
        pcount[n]=n*16;
        break;
        default:
        break;
  } 
 }
}

void ScanIN2(void)
{
unsigned int n=1;
if((cdata[n*16]=='*')&&(!in2)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='-')&&(!in2)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='+')&&(in2)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((istatus[n]==1)&&(Tdelay[n]==0))
 {
 pcount[n]++;
 if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
  switch (cdata[n*16])
  {
        case '+':
        case '-':
        Tdelay[n]=0;
        istatus[n]=2;
        pcount[n]=n*16;
        break;
        case '*':
        Tdelay[n]=0;
        istatus[n]=0;
        pcount[n]=n*16;
        break;        
        default:
        break;
  } 
 }
}

void ScanIN3(void)
{
unsigned int n=2;
if((cdata[n*16]=='*')&&(!in3)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='-')&&(!in3)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='+')&&(in3)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((istatus[n]==1)&&(Tdelay[n]==0))
 {
 pcount[n]++;
 if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
  switch (cdata[n*16])
  {
        case '+':
        case '-':
        Tdelay[n]=0;
        istatus[n]=2;
        pcount[n]=n*16;
        break;
        case '*':
        Tdelay[n]=0;
        istatus[n]=0;
        pcount[n]=n*16;
        break;        
        default:
        break;
  } 
 }
}

void ScanIN4(void)
{
unsigned int n=3;
if((cdata[n*16]=='*')&&(!in4)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='-')&&(!in4)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='+')&&(in4)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((istatus[n]==1)&&(Tdelay[n]==0))
 {
 pcount[n]++;
 if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
  switch (cdata[n*16])
  {
        case '+':
        case '-':
        Tdelay[n]=0;
        istatus[n]=2;
        pcount[n]=n*16;
        break;
        case '*':
        Tdelay[n]=0;
        istatus[n]=0;
        pcount[n]=n*16;
        break;        
        default:
        break;
  } 
 }
}

void ScanIN5(void)
{
unsigned int n=4;
if((cdata[n*16]=='*')&&(!in5)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='-')&&(!in5)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='+')&&(in5)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((istatus[n]==1)&&(Tdelay[n]==0))
 {
 pcount[n]++;
 if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
  switch (cdata[n*16])
  {
        case '+':
        case '-':
        Tdelay[n]=0;
        istatus[n]=2;
        pcount[n]=n*16;
        break;
        case '*':
        Tdelay[n]=0;
        istatus[n]=0;
        pcount[n]=n*16;
        break;        
        default:
        break;
  } 
 }
}

void ScanIN6(void)
{
unsigned int n=5;
if((cdata[n*16]=='*')&&(!in6)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='-')&&(!in6)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((cdata[n*16]=='+')&&(in6)&&(istatus[n]==0)){istatus[n]=1;pcount[n]=n*16;Tdelay[n]=0;}
if((istatus[n]==1)&&(Tdelay[n]==0))
 {
 pcount[n]++;
 if(cdata[pcount[n]]!=0)CommandInterpretator(n);else
  switch (cdata[n*16])
  {
        case '+':
        case '-':
        Tdelay[n]=0;
        istatus[n]=2;
        pcount[n]=n*16;
        break;
        case '*':
        Tdelay[n]=0;
        istatus[n]=0;
        pcount[n]=n*16;
        break;        
        default:
        break;
  } 
 }
}

void ScanIN78(void)
{
if((powsens!=powstate))
{
if(!powsens){istatus[6]=1;pcount[6]=6*16;Tdelay[6]=0;istatus[7]=0;pcount[7]=7*16;Tdelay[7]=0;}
else {istatus[7]=1;pcount[7]=7*16;Tdelay[7]=0;istatus[6]=0;pcount[6]=6*16;Tdelay[6]=0;}
}

if((istatus[6]==1)&&(Tdelay[6]==0))
 {
 pcount[6]++;
 if(cdata[pcount[6]]!=0)CommandInterpretator(6);else
  {
   Tdelay[6]=0;
   istatus[6]=0;
   pcount[6]=6*16;
  } 
 }
if((istatus[7]==1)&&(Tdelay[7]==0))
 {
 pcount[7]++;
 if(cdata[pcount[7]]!=0)CommandInterpretator(7);else
  {
   Tdelay[7]=0;
   istatus[7]=0;
   pcount[7]=7*16;
  } 
 }
 powstate=powsens;
}

void ScanIN9(void)
{
unsigned char i;
       	if((istatus[8]==0)&&w1_init())
      	{
      	for (i=0;i<8;i++)idata[i]=0;
        w1_search(0xf0,idata);
        if((w1_dow_crc8(idata,8)==0)&&SearchKey()&&(idata[0]!=0))
        {istatus[8]=1;pcount[8]=8*16;Tdelay[8]=0;ipwcnt=10;}
        }
if((istatus[8]==1)&&(Tdelay[8]==0))
 {
 pcount[8]++;
 if(cdata[pcount[8]]!=0)CommandInterpretator(8);else
  {
   Tdelay[8]=0;
   istatus[8]=0;
   pcount[8]=8*16;
  } 
 }
}

void ScanIN10(void)
{
char str[16];
unsigned char i,a,x;

if((iphone==0)&&(icall==0)&&(sms_counter!=0)&&(sms_proc==0)){SendSMS(GetSMS());sms_proc=6;}

if((iphone==0)&&(icall==0)&&(sms_proc==0))
{
iphone=1;
printf("AT+CLCC");
SendCR();
}

if((iphone==2)&&(icall==0))
{
iphone=3;
for(x=0;x<16;x++)str[x]=0;
x=0;i=0;
if(rx_counter)
while(rx_counter)
  {
  a=getchar();
  if((i==1)&&(a!='"')&&(x<16)){str[x]=a;x++;}
  if(a=='"')i++;
  }
if(istatus[9]==0)
 {  
 a=str[0];
 if(cdata[17*16+0]!=str[0])a=0;
 if(cdata[17*16+1]!=str[1])a=0;
 if(cdata[17*16+2]!=str[2])a=0;
 if(cdata[17*16+3]!=str[3])a=0;
 if(cdata[17*16+4]!=str[4])a=0;
 if(cdata[17*16+5]!=str[5])a=0;
 if(cdata[17*16+6]!=str[6])a=0;
 if(cdata[17*16+7]!=str[7])a=0;
 if(cdata[17*16+8]!=str[8])a=0;
 if(cdata[17*16+9]!=str[9])a=0;
 if(cdata[17*16+10]!=str[10])a=0;
 if(cdata[17*16+11]!=str[11])a=0;
 if(cdata[17*16+12]!=str[12])a=0;
 if(cdata[17*16+13]!=str[13])a=0;
 if(cdata[17*16+14]!=str[14])a=0;
 if(cdata[17*16+15]!=str[15])a=0;
 if(a)
  {
   Tdelay[9]=0;istatus[9]=1;pcount[9]=9*16;
   printf("ATH");SendCR();
  }
 }
 
if(istatus[10]==0)
 {  
 a=str[0];
 if(cdata[18*16+0]!=str[0])a=0;
 if(cdata[18*16+1]!=str[1])a=0;
 if(cdata[18*16+2]!=str[2])a=0;
 if(cdata[18*16+3]!=str[3])a=0;
 if(cdata[18*16+4]!=str[4])a=0;
 if(cdata[18*16+5]!=str[5])a=0;
 if(cdata[18*16+6]!=str[6])a=0;
 if(cdata[18*16+7]!=str[7])a=0;
 if(cdata[18*16+8]!=str[8])a=0;
 if(cdata[18*16+9]!=str[9])a=0;
 if(cdata[18*16+10]!=str[10])a=0;
 if(cdata[18*16+11]!=str[11])a=0;
 if(cdata[18*16+12]!=str[12])a=0;
 if(cdata[18*16+13]!=str[13])a=0;
 if(cdata[18*16+14]!=str[14])a=0;
 if(cdata[18*16+15]!=str[15])a=0;
 if(a)
  {
   Tdelay[10]=0;istatus[10]=1;pcount[10]=10*16;
   printf("ATH");SendCR();
  }
 }
 
if(istatus[11]==0)
 {  
 a=str[0];
 if(cdata[19*16+0]!=str[0])a=0;
 if(cdata[19*16+1]!=str[1])a=0;
 if(cdata[19*16+2]!=str[2])a=0;
 if(cdata[19*16+3]!=str[3])a=0;
 if(cdata[19*16+4]!=str[4])a=0;
 if(cdata[19*16+5]!=str[5])a=0;
 if(cdata[19*16+6]!=str[6])a=0;
 if(cdata[19*16+7]!=str[7])a=0;
 if(cdata[19*16+8]!=str[8])a=0;
 if(cdata[19*16+9]!=str[9])a=0;
 if(cdata[19*16+10]!=str[10])a=0;
 if(cdata[19*16+11]!=str[11])a=0;
 if(cdata[19*16+12]!=str[12])a=0;
 if(cdata[19*16+13]!=str[13])a=0;
 if(cdata[19*16+14]!=str[14])a=0;
 if(cdata[19*16+15]!=str[15])a=0;
 if(a)
  {
   Tdelay[11]=0;istatus[11]=1;pcount[11]=11*16;
   printf("ATH");SendCR();
  }
 }
}
        
if((istatus[9]==1)&&(Tdelay[9]==0))
 {
 pcount[9]++;
 if(cdata[pcount[9]]!=0)CommandInterpretator(9);else
  {
   Tdelay[9]=0;
   istatus[9]=0;
   pcount[9]=9*16;
  } 
 }
if((istatus[10]==1)&&(Tdelay[10]==0))
 {
 pcount[10]++;
 if(cdata[pcount[10]]!=0)CommandInterpretator(10);else
  {
   Tdelay[10]=0;
   istatus[10]=0;
   pcount[10]=10*16;
  } 
 }
if((istatus[11]==1)&&(Tdelay[11]==0))
 {
 pcount[11]++;
 if(cdata[pcount[11]]!=0)CommandInterpretator(11);else
  {
   Tdelay[11]=0;
   istatus[11]=0;
   pcount[11]=11*16;
  } 
 }
}

void main(void)
{
icall=0;
init_prog();
sledpw=1;
InitPhone();
InitDev();
bat=0;
zub=0;
zubdr=0;
batdr=0;
delay_ms(2000);

while (1)
 {
  	if(!key)
		{
		sec=200;
		sledpw=5;
		while(!key);
		if(sec<60)Read2Flash();
		if((sec<120)&&(sec>60))ProgKey();
		sledpw=1;
		}
 ScanIN1();
 ScanIN2();
 ScanIN3();
 ScanIN4();
 ScanIN5();
 ScanIN6();
 ScanIN78();
 ScanIN9();
 ScanIN10();		
 }
}
